
DoomFree_VariablesLoaded = false;

local DoomFreeConfig_default_ShowEndCap = false;
local DoomFreeConfig_active_ShowEndCap;

local DoomFreeConfig_default_InterruptAnnounce = true;
local DoomFreeConfig_active_InterruptAnnounce;

local DoomFreeConfig_default_PlayerX = 0;
local DoomFreeConfig_active_PlayerX;
local DoomFreeConfig_default_PlayerY = 0;
local DoomFreeConfig_active_PlayerY;
local DoomFreeConfig_default_TargetX = 0;
local DoomFreeConfig_active_TargetX;
local DoomFreeConfig_default_TargetY = 0;
local DoomFreeConfig_active_TargetY;
local DoomFreeConfig_default_PetX = 0;
local DoomFreeConfig_active_PetX;
local DoomFreeConfig_default_PetY = 0;
local DoomFreeConfig_active_PetY;

 local tmpPlySetPoint = PlayerFrame.SetPoint;
 local tmpTgtSetPoint = TargetFrame.SetPoint;
 local tmpTgtSetPoint = PetFrame.SetPoint;

local tmpChannel1 = nil; --DoomFree_Combat_Event(SPELL_INTERRUPT)

function DoomFree_Frame_Main_OnLoad(frm)
  --DEFAULT_CHAT_FRAME:AddMessage("DoomFree_Frame_Main_OnLoad()");
  
  --register events
  frm:RegisterEvent("PLAYER_ENTERING_WORLD");
  frm:RegisterEvent("RAID_ROSTER_UPDATE");
  frm:RegisterEvent("PARTY_MEMBERS_CHANGED");
  
  frm:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED");
  
end

function DoomFree_Frame_Main_OnEvent(frm, event, ...)
  --DEFAULT_CHAT_FRAME:AddMessage("DoomFree_Frame_Main_OnEvent()");
  
  if (event == "COMBAT_LOG_EVENT_UNFILTERED") then
    DoomFree_Combat_Event(...);
  elseif ((event == "RAID_ROSTER_UPDATE") or (event == "PARTY_MEMBERS_CHANGED")) then
    DoomFree_Group_Update();
  elseif (event == "PLAYER_ENTERING_WORLD") then
    DoomFree_Load();
  end
end 

function DoomFree_Combat_Event(...) 
  --DEFAULT_CHAT_FRAME:AddMessage("DoomFree_Combat_Event()");
  
  local timestamp, event_type, dummy, source_GUID, source_name, source_flags, dest_GUID, dest_name, dest_flags = select(1, ...);
  --DEFAULT_CHAT_FRAME:AddMessage("DoomFree_Combat_Event() 1 "..event_type.." GUID "..source_GUID);
  if ((event_type=="SPELL_INTERRUPT") and DoomFreeConfig_active_InterruptAnnounce and (UnitGUID("player")==source_GUID)) then  
    local source_spellID, source_spellName, source_spellSchool, target_spellID, target_spellName, target_spellSchool = select(10, ...);
    --SendChatMessage("Interrupted "..GetSpellLink(target_spellID), tmpChannel1);
    SendChatMessage("Interrupted "..target_spellName.." ("..dest_name..") ", tmpChannel1);    
  end
end

function DoomFree_Group_Update()
  --DEFAULT_CHAT_FRAME:AddMessage("DoomFree_Group_Update()");
  
  tmpChannel1 = nil;
  if (GetNumPartyMembers() ~= 0) then 
    tmpChannel1 = "PARTY";
  end
  if (GetNumRaidMembers() ~= 0) then 
    tmpChannel1 = "RAID";
  end
end

function DoomFree_Load()  
  --DEFAULT_CHAT_FRAME:AddMessage("DoomFree_Load()");
  
  if ( not DoomFree_VariablesLoaded ) then
    DoomFree_Initialize();
  end
  
  DoomFreeConfig_Apply();
  DoomFree_UpdateDisplay();
  DoomFree_UpdateRegisteredEvents();

end 

function DoomFree_Initialize()
  
  --DEFAULT_CHAT_FRAME:AddMessage("DoomFree_Initialize()");

  if ( not DoomFreeConfig ) then
    DoomFreeConfig = {}; 
  end
  
  if ( DoomFreeConfig.EndCap == nil ) then 
    DoomFreeConfig.EndCap = DoomFreeConfig_default_ShowEndCap; 
  end
  if ( DoomFreeConfig.InterruptAnnounce == nil ) then 
    DoomFreeConfig.InterruptAnnounce = DoomFreeConfig_default_InterruptAnnounce; 
  end
  if ( DoomFreeConfig.PlayerX == nil ) then 
    DoomFreeConfig.PlayerX = DoomFreeConfig_default_PlayerX; 
  end
  if ( DoomFreeConfig.PlayerY == nil ) then 
    DoomFreeConfig.PlayerY = DoomFreeConfig_default_PlayerY; 
  end
  if ( DoomFreeConfig.TargetX == nil ) then 
    DoomFreeConfig.TargetX = DoomFreeConfig_default_TargetX; 
  end
  if ( DoomFreeConfig.TargetY == nil ) then 
    DoomFreeConfig.TargetY = DoomFreeConfig_default_TargetY; 
  end
  if ( DoomFreeConfig.PetX == nil ) then 
    DoomFreeConfig.PetX = DoomFreeConfig_default_PetX; 
  end
  if ( DoomFreeConfig.PetY == nil ) then 
    DoomFreeConfig.PetY = DoomFreeConfig_default_PetY; 
  end
  
  DoomFree_VariablesLoaded = true;
end

function DoomFreeConfig_Apply() 
  --DEFAULT_CHAT_FRAME:AddMessage("DoomFreeConfig_Apply()");
  
  DoomFreeConfig_active_ShowEndCap = DoomFreeConfig.EndCap;
  DoomFreeConfig_active_InterruptAnnounce = DoomFreeConfig.InterruptAnnounce;
  DoomFreeConfig_active_PlayerX    = DoomFreeConfig.PlayerX;
  DoomFreeConfig_active_PlayerY    = DoomFreeConfig.PlayerY;
  DoomFreeConfig_active_TargetX    = DoomFreeConfig.TargetX;
  DoomFreeConfig_active_TargetY    = DoomFreeConfig.TargetY;
  DoomFreeConfig_active_PetX    = DoomFreeConfig.PetX;
  DoomFreeConfig_active_PetY    = DoomFreeConfig.PetY;
end

function DoomFree_UpdateRegisteredEvents()
  DoomFree_Frame_Main:UnregisterEvent("COMBAT_LOG_EVENT_UNFILTERED");
  
  if DoomFreeConfig_active_InterruptAnnounce then
    DoomFree_Frame_Main:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED");
  end
end;

function DoomFree_UpdateDisplay()
  
  if (not DoomFreeConfig_active_ShowEndCap) then
    -- hide action bar graphic when I login
    MainMenuBarLeftEndCap:Hide();
    MainMenuBarRightEndCap:Hide();
  else 
    MainMenuBarLeftEndCap:Show();
    MainMenuBarRightEndCap:Show();
  end
  
  --DEFAULT_CHAT_FRAME:AddMessage("DoomFree_UpdateDisplay() "..DoomFreeConfig_active_PlayerX..","..DoomFreeConfig_active_PlayerY);
    
   PlayerFrame.SetPoint = tmpPlySetPoint;
   TargetFrame.SetPoint = tmpTgtSetPoint;
   PetFrame.SetPoint = tmpPetSetPoint;
  
  PlayerFrame:ClearAllPoints();
  PlayerFrame:SetPoint("CENTER", UIParent, "CENTER", DoomFreeConfig_active_PlayerX, DoomFreeConfig_active_PlayerY);
  
  TargetFrame:ClearAllPoints();
  TargetFrame:SetPoint("CENTER", UIParent, "CENTER", DoomFreeConfig_active_TargetX, DoomFreeConfig_active_TargetY);  
  
  --FocusFrame:ClearAllPoints();
  --FocusFrame:SetPoint("CENTER", UIParent, "CENTER", , );
  
  --if (PetFrame:IsShown()) then
  if (UnitExists("pet")) then
    --DEFAULT_CHAT_FRAME:AddMessage("DoomFree_UpdateDisplay() 1");
    PetFrame:Show();
    PetFrame:ClearAllPoints();
    PetFrame:SetPoint("CENTER", UIParent, "CENTER", DoomFreeConfig_active_PetX, DoomFreeConfig_active_PetY);
  end
  
   PlayerFrame.SetPoint = function() end;
   TargetFrame.SetPoint = function() end;
   PetFrame.SetPoint = function() end;
  
end